#!/usr/bin/env python
# encoding: utf-8
"""
befriender_handler.py

Contains class initialized for each login from a befriender. 

Created by Elliot Pennington on 2008-11-23.
"""

from socket import *
import message, dispatcher


class BefrienderHandler:
    
    """
    Handle requests from a befriender client. Runs in a new thread.
    
    Args:
        request: The socket descriptor for the connection to the befriender
                    machine
        client_addr: The address information for the connecting befriender 
    """
    
    def __init__(self, request, client_addr):
        self.request = request
        self.client_addr = client_addr
        self.handle()
#        except:
#            print "handler error!"
#    

    def handle(self):
        """
        Wait for incoming requests from the befriender forever. When a request is
            received, format it into a Message object then send it to the dispatcher.
        """
        while 1:
            try:
                indata = self.request.recv(1024)
            except:
                self.die()
                break
            if not indata:
                self.die()
                break
            msg = message.Message(indata)
            if not msg.getSn() == "~server":
                print "bogus recv."
            try:
                dispatcher.dispatch_internal_msg(msg, self.request)
            except:
                continue
        self.request.close()
    
    def die(self):
        dispatcher.befrienders.remove(self.request)
        

# class handlerTests(unittest.TestCase):
#     def setUp(self):
#         pass
# 
# 
# if __name__ == '__main__':
#     unittest.main()